
/* include the library headers */
#include <lcrzo.h>
#include <stdlib.h>
#include <stdio.h>

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000096=
{ /*reference*/     "lcrzoex", 96,
  /*version*/       1, 0,
  /*title*/         "real tcp client [web head]",
  /*french title*/  "client tcp reel [web head]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port",
  /*french usage*/  "nom_serveur port_serveur",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000096_main(int argc, char *argv[]);
int lcrzoex_000096_web_head(lcrzo_sock sock);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000096_main(int argc, char *argv[])
{ lcrzo_ipl ipl;
  lcrzo_sock sock;

  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000096, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  lcrzo_epr(lcrzo_ipl_init_hs(argv[1], &ipl));
  lcrzo_epr(lcrzo_sock_tcpcli_real(ipl, (lcrzo_uint16)atoi(argv[2]), &sock));
  lcrzo_epr(lcrzoex_000096_web_head(sock));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000096_web_head(lcrzo_sock sock)
{ lcrzo_data data;
  lcrzo_int32 datasize;
 
  /* first, we send a 'head' */
  lcrzo_epr(lcrzo_data_initm_text("HEAD / HTTP/1.0\n\n", &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(sock, data, datasize));
  free(data);

  /* then, we read the data (to simplify, we read only once) */
  lcrzo_epr(lcrzo_sock_readm(&sock, LCRZO_TRUE, &data, &datasize));
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_DUMP));
  free(data);

  /* close the socket */
  lcrzo_epr(lcrzo_sock_close(sock));
  return (LCRZO_ERR_OK);
}
