
/* include the library headers */
#include <lcrzo.h>
#include <stdlib.h>
#include <stdio.h>

/* set information about this example */
lcrzoex_infos lcrzoex_000161=
{ /*reference*/     "lcrzoex", 161, 
  /*version*/       1, 0, 
  /*title*/         "convert an IP/mask address", 
  /*french title*/  "convertit une adresse IP/masque", 
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "ip/mask OR IPinf-IPsup",
  /*french usage*/  "ip/masque OU IPinf-IPsup", 
  /*author*/        "Laurent"
};

/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000161_main(int argc, char *argv[]);
int lcrzoex_000161_main(int argc, char *argv[])
{ lcrzo_ipl iplinf, iplsup, surroundinf, surroundsup, mask;
  lcrzo_iprange iprange;
  int language, i;

  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000161, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }


  /* print both IP addresses */
  lcrzo_epr(lcrzo_ipl_init_iprange(argv[1], &iplinf, &iplsup));
  lcrzo_ipl_print("IP inf :  ", iplinf, "\n");
  lcrzo_ipl_print("IP sup :  ", iplsup, "\n");

  /* print the range */
  lcrzo_epr(lcrzo_iprange_init_ipl(iplinf, iplsup, iprange));
  printf("Range  :  %s\n", iprange);

  /* calculate the surrounding range */
  mask=0;
  for ( i=0 ; i<32 ; i++ )
  { if ( (iplinf|mask) == (iplsup|mask) ) break;
    mask = 1|(mask<<1);
  }
  surroundinf=iplinf&(~mask);
  surroundsup=iplinf|mask;

  /* eventually print it */
  if ( surroundinf!=iplinf || surroundsup!=iplsup )
  { lcrzo_epr(lcrzo_global_get_language(&language));
    if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Intervalle encadrant :\n");
    else
      printf("Surrounding range :\n");
 
    /* print both IP addresses */
    lcrzo_epr(lcrzo_ipl_init_iprange(argv[1], &iplinf, &iplsup));
    lcrzo_ipl_print("  IP inf :  ", surroundinf, "\n");
    lcrzo_ipl_print("  IP sup :  ", surroundsup, "\n");
    /* print the range */
    lcrzo_epr(lcrzo_iprange_init_ipl(surroundinf, surroundsup, iprange));
    printf("  Range  :  %s\n", iprange);
  }

  return(LCRZO_ERR_OK);
}
